package ru.landgrafhomyak.serdha.api.v0.queries

import ru.landgrafhomyak.serdha.api.v0.misc.Column
import ru.landgrafhomyak.serdha.api.v0.table.Table
import ru.landgrafhomyak.serdha.api.v0.misc.DatabaseType
import ru.landgrafhomyak.serdha.api.v0.misc.DatabaseTypesProvider
import ru.landgrafhomyak.serdha.api.v0.misc.QueryParam
import ru.landgrafhomyak.serdha.api.v0.runtime.ParametersSetter

public interface UpdateQuery<QueryUserExtension : Any> : _Selectable<QueryUserExtension> {
	public val userExtension: QueryUserExtension

	public interface Creator<QueryUserExtension : Any, TargetTableUserExtension : Any, SelectorTableUserExtension : Any> {
		public fun createUpdateWithReturning(table: Table<TargetTableUserExtension, *>, creator: Scope<QueryUserExtension, TargetTableUserExtension, SelectorTableUserExtension>): QueryUserExtension

		public interface Scope<QueryUserExtension : Any, TargetTableUserExtension : Any, SelectorTableUserExtension : Any> {
			public val types: DatabaseTypesProvider
			public fun <RT, DT : DatabaseType<RT>> param(name: String, type: DT): QueryParam<RT, DT, QueryUserExtension>

			public val selectorParams: ParametersSetter.WithRedirect<SelectorTableUserExtension, QueryUserExtension>
			public var selectorColumn: Column<*, DatabaseType.ROW_ID<TargetTableUserExtension>, SelectorTableUserExtension>

			public fun <RT, DT : DatabaseType<RT>> updateColumnWithSubquery(c: Column<RT, DT, TargetTableUserExtension>, e: Column<RT, DT, SelectorTableUserExtension>)
			public fun <RT, DT : DatabaseType<RT>> updateColumnWithOldValue(c: Column<RT, DT, TargetTableUserExtension>, e: Column<RT, DT, TargetTableUserExtension>)
			public fun <RT, DT : DatabaseType<RT>> updateColumnWithParam(c: Column<RT, DT, TargetTableUserExtension>, e: QueryParam<RT, DT, QueryUserExtension>)

			public fun <RT, DT : DatabaseType<RT>> returnFromSubquery(c: Column<RT, DT, SelectorTableUserExtension>): Column<RT, DT, QueryUserExtension>
			public fun <RT, DT : DatabaseType<RT>> returnOldValue(c: Column<RT, DT, TargetTableUserExtension>): Column<RT, DT, QueryUserExtension>
			public fun <RT, DT : DatabaseType<RT>> returnNewValue(c: Column<RT, DT, TargetTableUserExtension>): Column<RT, DT, QueryUserExtension>
			public fun <RT, DT : DatabaseType<RT>> returnParam(c: QueryParam<RT, DT, TargetTableUserExtension>): Column<RT, DT, QueryUserExtension>
		}
	}
}